/* * 
 * This file is part of Flux
 *
 * Copyright (C) 2009 by LScube team <team@lscube.org>
 * See AUTHORS for more details
 * 
 * flux is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * flux is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with flux; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA 
 *
 * */


#ifndef _FLUX_CHAIN_
#define _FLUX_CHAIN_

#include <list>

#include "../io/io.hpp"
#include "../utils/ref.hpp"
#include "../parser/parser.hpp"

namespace flux
{
  struct Chain
  {
    typedef std::list< RefCounted<io::Input> > InputList;
    typedef std::list< RefCounted<io::Output> > OutputList;

    parse::Parser *parser;
    InputList inputs;
    OutputList outputs;

    Chain(parse::Parser * parse);
    ~Chain();

    private:
      Chain(Chain const &other);
  };
}


#endif
