/* * 
 * This file is part of Flux
 *
 * Copyright (C) 2009 by LScube team <team@lscube.org>
 * See AUTHORS for more details
 * 
 * flux is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * flux is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with flux; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA 
 *
 * */


#include <string>
#include <list>

%%{
	machine flux;

        el=(any-'*'-',')+ >{ mark=fpc; } %{ current.push_back(std::string(mark, fpc-mark)); };
	input=el ( "," el )* %{ inputs.insert(inputs.begin(), current.begin(), current.end()); current.clear(); };
	output=el ( "," el )* %{ outputs.insert(outputs.begin(), current.begin(), current.end()); current.clear(); };
	parser=(any-'*')+ >{ mark=fpc; } %{ parser_name = std::string(mark, fpc-mark); };

	chain_line=input "*" parser "*" output 0;
	
	chain:=chain_line;
}%%

%%write data;

bool chain_parse(std::string const &text, std::list<std::string> &inputs, std::string &parser_name, std::list<std::string> &outputs)
{
  int cs;
  char const *p = text.c_str();
  char const *pe = text.c_str() + text.size() + 1;
  char const *mark;
  //char const *eof;
  std::list<std::string> current;

  %%write init;
  %%write exec;

  if ( (cs == flux_error) || (cs < flux_first_final) )
    return false;

  return true;
}

