/* *
 * This file is part of Flux
 *
 * Copyright (C) 2009 by LScube team <team@lscube.org>
 * See AUTHORS for more details
 *
 * flux is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * flux is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with flux; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * */


#ifndef _FLUX_LIVE_PARSER_
#define _FLUX_LIVE_PARSER_

#include "parser.hpp"
#include <list>

namespace flux
{
    namespace parse
    {
        class LiveParser : public Parser
        {
            protected:
                rtp::Packet p_;
                unsigned long ssrc_;
                unsigned long last_timestamp_;
                unsigned long prev_ts_;
                int last_seq_;

            public:
                static Parser *Alloc(std::string const &opts);

                LiveParser();
                ~LiveParser();

                bool parse(rtp::Packet const &p);
                unsigned char *getResult();
                unsigned long getResultSize();
                bool hasMore();
        };

#ifdef TRANSCODE
        class EmptyLiveParser : public LiveParser
        {
            protected:
                unsigned long int last_valid_input_time_;
                std::list<rtp::Packet *> black_pkts_;
                std::list<rtp::Packet *> pkts_to_send_;
                unsigned long int fake_seq_;
                unsigned int frame_num_;

            public:
                static Parser *Alloc(std::string const &opts);

                EmptyLiveParser();
                ~EmptyLiveParser();

                bool parse(rtp::Packet const &p);
                unsigned char *getResult();
                unsigned long getResultSize();
                bool hasMore();
        };
#endif

    }
}

#endif
