/* * 
 * This file is part of Flux
 *
 * Copyright (C) 2009 by LScube team <team@lscube.org>
 * See AUTHORS for more details
 * 
 * flux is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * flux is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with flux; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA 
 *
 * */


#ifndef _FLUX_PARSER_UNPACK_
#define _FLUX_PARSER_UNPACK_

#include "parser.hpp"

namespace flux
{
  namespace rtp { class Depacketizer; }

  namespace parse
  {
    class UnpackParser : public Parser
    {
      private:
        rtp::Depacketizer *depacker_;
        unsigned char *buffer_;
        unsigned long int buffer_size_;

      public:
        static Parser *Alloc(std::string const &opts);

        UnpackParser();
        ~UnpackParser();

        bool parse(rtp::Packet const &p);
        unsigned char *getResult();
        unsigned long getResultSize();
        bool hasMore();
    };
  }
}

#endif
