/* * 
 * This file is part of Flux
 *
 * Copyright (C) 2009 by LScube team <team@lscube.org>
 * See AUTHORS for more details
 * 
 * flux is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * flux is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with flux; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA 
 *
 * */


#ifndef _LIBRTP_MPEG_VIDEO_PACK_
#define _LIBRTP_MPEG_VIDEO_PACK_

#include "packetizer.hpp"

namespace flux
{
    namespace rtp
    {
        class MpegVideoPacketizer : public Packetizer
        {
            private:
                unsigned long seq_;

            public:
                MpegVideoPacketizer(unsigned long ssrc);
                ~MpegVideoPacketizer();

                int parse(std::list<Packet*> &plist, unsigned char *data, long len, unsigned char *extradata, long extradata_len);
        };
    }
}

#endif

