/* *
 * This file is part of Flux
 *
 * Copyright (C) 2009 by LScube team <team@lscube.org>
 * See AUTHORS for more details
 *
 * flux is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * flux is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with flux; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * */


#ifndef _LIBRTP_MPEG_VIDEO_UNPACK_
#define _LIBRTP_MPEG_VIDEO_UNPACK_

#include "depacketizer.hpp"

namespace flux
{
  namespace rtp
  {
    class MpegVideoDepacketizer : public Depacketizer
    {
      protected:
        unsigned char *data;
        unsigned long len;
        unsigned long data_size;
        unsigned long timestamp;

      public:
        MpegVideoDepacketizer();
        ~MpegVideoDepacketizer();
        Depacketizer::ParseResult parse(Packet const &packet, Depacketizer::FrameBuffer *destination_frame_buffer,
                                        Depacketizer::ConfigBuffer *destination_config_buffer);
    };
  }
}

#endif
