/* *
 * This file is part of Flux
 *
 * Copyright (C) 2009 by LScube team <team@lscube.org>
 * See AUTHORS for more details
 *
 * flux is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * flux is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with flux; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * */


#ifndef _FLUX_METADATA_H_
#define _FLUX_METADATA_H_

#include <map>

namespace flux
{
    class MQMetaData
    {
        public:
            static unsigned const Size = sizeof(double)+sizeof(unsigned int)*2;

        private:
            typedef std::map< void*, std::pair<double, unsigned int> > StartTimesMap;

            static StartTimesMap StartTimes_;
            char buffer_[Size];

            static std::pair<double, unsigned int> &GetStartTime(void *id, unsigned int cur_ts);

        public:
            MQMetaData();
            ~MQMetaData();

            static void Rebase(void *id);
            void rebuild(void *id, unsigned int cur_ts);
            inline char const *getData() const { return buffer_; }
            inline unsigned getSize() const { return Size; }
    };
}

#endif
